/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         CQLSTYPE
/* Substitute the variable and function names.  */
#define yyparse         cqlparse
#define yylex           cqllex
#define yyerror         cqlerror
#define yydebug         cqldebug
#define yynerrs         cqlnerrs

#define yylval          cqllval
#define yychar          cqlchar

/* Copy the first part of user declarations.  */
#line 4 "cqpeval.y" /* yacc.c:339  */


#include "config.hh"
#include "finlib/fstream.hh"
#include "frsop.hh"
#include "corpus.hh"
#include "parsop.hh"
#include "utf8.hh"
#include "cqpeval.hh"

#include <iostream>
using namespace std;

string errMsg;

string query;
static ssize_t pos = -1;  // position after the current lexer token
static ssize_t startpos = -1;  // position before the current lexer token
static bool onepos = false;

extern "C" {
     int yyparse(void);
     int yylex(void);
     void yyerror(char const* s) {
          stringstream ss;
          ss << s << " near position " << utf8pos(query.c_str(), startpos);
          errMsg = ss.str();
     }
     int cqlwrap() {
          return 1;
     }
}

Corpus* currCorp, *alCorp, *tmpCorp;
Corpus* defaultCorp;
Structure* currStruc;
Position lastPosition;

PosAttr* getAttr(string name) {
     return currCorp->get_attr(name);
}

PosAttr* getAttr(const char* name) {
     string s(name);
     return getAttr(s);
}

const char* unescapeString(const char* s) {
     size_t len = strlen(s);
     char* unescaped = new char[len+1];
     size_t i, j;
     for (i = 0, j = 0; i < len; i++, j++) {
          if (s[i] == '\\' && i + 1 < len && (s[i + 1] == '"' || s[i + 1] == '\\'))
               i++;
          unescaped[j] = s[i];
     }
     unescaped[j] = '\0';
     return unescaped;
}

FastStream* exactMatch(const char* attrName, const char* str) {
    PosAttr* attr = getAttr(attrName);
    int id = attr->str2id(unescapeString(str));
     return attr->id2poss(id);
}

const int WORD_LESS_OR_EQUALS = -1;
const int WORD_GREATER_OR_EQUALS = 1;
const bool ignoreCase = false;

struct globOp {
     RQFilterFreq::Op op;
     int neg;
};

struct rep {
     int min, max;
};

struct evalResult {
     RangeStream* r;
     FastStream* f;
     int fcount;
     RangeStream* toRangeStream() {
          if (f != NULL) {
               return new Pos2Range(f, 0, fcount);
          }
          return r;
     }
     evalResult complement() {
          RangeStream* r = toRangeStream();
          evalResult ret;
          ret.f = NULL;
          ret.fcount = 0;
          ret.r = new RQoutsideNode(r, defaultCorp->size());
          return ret;
     }
};

evalResult createEvalResult(FastStream* f, int count=1) {
     evalResult ret;
     ret.r = NULL;
     ret.f = f;
     ret.fcount = count;
     return ret;
}

evalResult createEvalResult(RangeStream* r) {
     evalResult ret;
     ret.r = r;
     ret.f = NULL;
     ret.fcount = 0;
     return ret;
}

evalResult concat(evalResult e1, evalResult e2) {
     RangeStream* r1 = e1.r;
     RangeStream* r2 = e2.r;
     if (r1 != NULL || r2 != NULL) {
          bool sortBeg = false;
          if (r1 == NULL) {
               r1 = e1.toRangeStream();
          } else {
               r1 = new RQSortEnd(r1);
               sortBeg = true;
          }
          if (r2 == NULL) {
               r2 = e2.toRangeStream();
          }
          RangeStream* c = RQConcatNodeUnsort(r1, r2);
          if (sortBeg) {
               c = new RQSortBeg(c);
          }
          return createEvalResult(c);
     }
     FastStream* c = new QAndNode(e1.f, new QMoveNode(e2.f, -1*e1.fcount));
     return createEvalResult(c, e1.fcount + e2.fcount);
}

evalResult operationOr(evalResult e1, evalResult e2) {
     RangeStream* r1 = e1.r;
     RangeStream* r2 = e2.r;
     if (r1 != NULL || r2 != NULL || e1.fcount != e2.fcount) {
          if (r1 == NULL) {
               r1 = e1.toRangeStream();
          }
          if (r2 == NULL) {
               r2 = e2.toRangeStream();
          }
          return createEvalResult(new RQUnionNode(r1, r2));
     }
     return createEvalResult(new QOrNode(e1.f, e2.f), e1.fcount);
}


FastStream* concatFs(FastStream* f1, FastStream* f2) {
     return new QAndNode(f1, new QMoveNode(f2, -1));
}

evalResult queryResult;
stringstream seek;


#line 239 "cqpeval.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Debug traces.  */
#ifndef CQLDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define CQLDEBUG 1
#  else
#   define CQLDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define CQLDEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined CQLDEBUG */
#if CQLDEBUG
extern int cqldebug;
#endif

/* Token type.  */
#ifndef CQLTOKENTYPE
# define CQLTOKENTYPE
  enum cqltokentype
  {
    START_QUERY = 258,
    START_ONEPOS = 259,
    WORD = 260,
    REGEXP = 261,
    LBRACKET = 262,
    RBRACKET = 263,
    LPAREN = 264,
    RPAREN = 265,
    LBRACE = 266,
    RBRACE = 267,
    NOT = 268,
    EQ = 269,
    NEQ = 270,
    LEQ = 271,
    GEQ = 272,
    LSTRUCT = 273,
    RSTRUCT = 274,
    BIN_AND = 275,
    BIN_OR = 276,
    STAR = 277,
    PLUS = 278,
    QUEST = 279,
    SLASH = 280,
    POSNUM = 281,
    COMMA = 282,
    COLON = 283,
    DOT = 284,
    TEQ = 285,
    NNUMBER = 286,
    NUMBER = 287,
    KW_MEET = 288,
    KW_UNION = 289,
    KW_WITHIN = 290,
    KW_CONTAINING = 291,
    KW_WS = 292,
    KW_SWAP = 293,
    KW_CCOLL = 294,
    KW_FREQ = 295,
    KW_TERM = 296
  };
#endif
/* Tokens.  */
#define START_QUERY 258
#define START_ONEPOS 259
#define WORD 260
#define REGEXP 261
#define LBRACKET 262
#define RBRACKET 263
#define LPAREN 264
#define RPAREN 265
#define LBRACE 266
#define RBRACE 267
#define NOT 268
#define EQ 269
#define NEQ 270
#define LEQ 271
#define GEQ 272
#define LSTRUCT 273
#define RSTRUCT 274
#define BIN_AND 275
#define BIN_OR 276
#define STAR 277
#define PLUS 278
#define QUEST 279
#define SLASH 280
#define POSNUM 281
#define COMMA 282
#define COLON 283
#define DOT 284
#define TEQ 285
#define NNUMBER 286
#define NUMBER 287
#define KW_MEET 288
#define KW_UNION 289
#define KW_WITHIN 290
#define KW_CONTAINING 291
#define KW_WS 292
#define KW_SWAP 293
#define KW_CCOLL 294
#define KW_FREQ 295
#define KW_TERM 296

/* Value type.  */
#if ! defined CQLSTYPE && ! defined CQLSTYPE_IS_DECLARED

union CQLSTYPE
{
#line 168 "cqpeval.y" /* yacc.c:355  */

     long long num;
     const char* str;
     evalResult evalRes;
     FastStream* fs;
     RangeStream* rs;
     rep repData;
     globOp globop;
     int i;

#line 377 "cqpeval.cc" /* yacc.c:355  */
};

typedef union CQLSTYPE CQLSTYPE;
# define CQLSTYPE_IS_TRIVIAL 1
# define CQLSTYPE_IS_DECLARED 1
#endif


extern CQLSTYPE cqllval;

int cqlparse (void);



/* Copy the second part of user declarations.  */

#line 394 "cqpeval.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined CQLSTYPE_IS_TRIVIAL && CQLSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  40
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   362

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  117
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  234

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if CQLDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   204,   204,   208,   215,   219,   223,   230,   234,   238,
     245,   249,   256,   261,   266,   271,   276,   281,   286,   291,
     299,   303,   309,   313,   319,   323,   327,   333,   337,   341,
     348,   352,   356,   363,   371,   371,   385,   385,   399,   403,
     407,   411,   418,   422,   429,   433,   450,   455,   459,   467,
     471,   475,   482,   487,   492,   497,   502,   507,   512,   520,
     525,   524,   537,   541,   548,   552,   556,   560,   564,   568,
     575,   583,   594,   602,   613,   617,   624,   628,   646,   650,
     657,   664,   668,   675,   679,   685,   685,   685,   685,   685,
     685,   686,   686,   686,   686,   690,   694,   700,   701,   701,
     705,   709,   714,   718,   723,   727,   732,   736,   741,   745,
     749,   753,   757,   768,   779,   790,   801,   807
};
#endif

#if CQLDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "START_QUERY", "START_ONEPOS", "WORD",
  "REGEXP", "LBRACKET", "RBRACKET", "LPAREN", "RPAREN", "LBRACE", "RBRACE",
  "NOT", "EQ", "NEQ", "LEQ", "GEQ", "LSTRUCT", "RSTRUCT", "BIN_AND",
  "BIN_OR", "STAR", "PLUS", "QUEST", "SLASH", "POSNUM", "COMMA", "COLON",
  "DOT", "TEQ", "NNUMBER", "NUMBER", "KW_MEET", "KW_UNION", "KW_WITHIN",
  "KW_CONTAINING", "KW_WS", "KW_SWAP", "KW_CCOLL", "KW_FREQ", "KW_TERM",
  "$accept", "list", "query", "globCond", "globPart", "globCondCmp",
  "within_containing", "within_containing_sufix", "within_number",
  "aligned_part_labels", "$@1", "aligned_part_no_labels", "$@2",
  "sequence", "seq", "repetition", "atomQuery", "repOpt", "structure",
  "$@3", "position", "oneposition", "thesaurus", "thesaurus_default",
  "muPart", "meetOp", "integer", "unionOp", "attvallist", "attvaland",
  "word", "wsseekpart", "wsseek", "$@4", "attval", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296
};
# endif

#define YYPACT_NINF -97

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-97)))

#define YYTABLE_NINF -60

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     174,   195,   235,    22,   -97,   198,     5,   123,   252,    15,
      67,    92,     9,    44,   -97,   208,   123,   -97,   127,   -97,
     -97,   -97,   -97,   -97,   235,   235,   102,   -97,   -97,   -97,
     -97,   104,   131,   135,   -97,   137,   133,   138,   288,   -97,
     -97,   -97,   175,    81,   236,   150,   150,    92,   180,   244,
     183,   185,   123,    45,   -97,   -97,   -97,   -97,    42,    68,
     -97,   199,   103,   206,    36,    85,   -13,   249,   -97,   149,
     -97,   -97,   -97,   -97,   121,   -97,   212,    25,   194,   215,
      26,   235,   235,   229,    82,   100,   224,   257,   -97,   -97,
      30,   226,   150,   150,   -97,   -97,   -97,   -97,   259,   -97,
     261,   235,   -97,   -97,   130,   130,   182,    67,   -97,   -97,
     -97,   263,   280,   182,   -97,   -97,   282,   303,   123,   123,
     283,     3,   -97,   -97,   286,   287,   289,   290,   291,   294,
     138,   -97,   313,   314,   -97,   316,   -97,   317,   -97,   -97,
     -97,   318,   251,   -97,   -97,   -97,   133,   166,   -97,   -97,
     297,   -97,   -97,   -97,   -97,   -97,   -97,    45,   295,   123,
     319,   -97,    12,   320,   296,   235,   298,   323,   296,   -97,
     -97,   -97,   -97,   -97,   -97,   -97,   251,   -97,   195,   292,
     304,   -97,   -97,   322,   305,   -97,   -97,     6,   164,   308,
     309,    18,   -97,   195,   263,   306,   307,    45,   -97,   331,
     -97,   -97,   -97,   235,   334,   -97,   263,   312,   315,   332,
     333,   296,   176,   335,    45,    45,   281,   -97,   -97,   -97,
     -97,   -97,   -97,   293,   -97,   -97,   -97,   -97,   -97,   -97,
     321,   -97,   -97,   -97
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     2,     5,     0,     6,     4,    38,    42,    44,    49,
      62,    67,    68,    85,     0,     0,     0,    86,    87,    88,
      89,    91,    93,    94,    90,    92,     3,    81,     0,    83,
       1,    69,     0,     0,     0,     0,     0,     0,     6,     4,
       0,     0,    39,     0,    91,    93,    94,    92,     0,    60,
      73,     0,     0,     0,     0,     0,     0,     0,    43,     0,
      52,    53,    54,    45,     0,   110,   108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    66,    65,
       0,     0,     0,     0,    51,    50,    74,    75,     0,    46,
       0,     0,    72,    63,     0,     0,     0,    33,    20,    30,
      24,    32,     0,     0,    22,    27,     0,     0,     0,    40,
       0,     0,   111,   109,     0,     0,     0,     0,     0,     0,
      82,    84,     0,     0,   100,     0,   101,     0,   104,   106,
      71,     0,    76,    80,    48,    47,    61,     0,    21,    26,
       0,    23,    29,    31,    25,    34,    28,     0,     0,    41,
       0,    55,     0,     0,    96,     0,     0,     0,    96,   105,
     107,   102,   103,    70,    79,    78,     0,    36,     0,     0,
       0,    57,    58,     0,     0,    95,    97,     0,     0,     0,
       0,     0,    77,     0,    35,     0,     0,     0,    56,     0,
     112,    98,   116,     0,     0,   113,    37,     0,     0,     0,
       0,    96,     0,     0,     0,     0,     0,   114,    99,   117,
     115,     7,     8,     0,    12,    13,    14,    15,    16,    18,
       0,    19,    17,     9
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -97,   -97,   340,   -97,   -97,   -97,   341,   -52,   -96,   284,
     -97,   -80,   -97,     1,    -2,   -12,   -97,   -97,   299,   -97,
     -37,   300,   -97,   -97,   -97,   -97,   172,   -97,    -4,   269,
      -5,   140,   186,   -97,   -19
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,    11,    12,    13,   230,    14,   108,   109,   110,
     178,   149,   193,   111,    16,    17,    18,    73,    58,   101,
      19,    20,    42,    21,    22,    50,   176,    51,    36,    37,
      38,   186,   187,   211,    39
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      44,    43,    15,    59,    68,    52,    75,    49,    92,    93,
     153,     4,     5,   114,     6,   161,   200,   153,     7,   116,
      74,    60,    40,     8,   182,   152,   154,   117,   205,   -10,
     162,   124,   128,   156,   201,     9,   140,    10,    45,    46,
      68,    23,     4,     5,   183,     6,   201,    61,    59,   106,
      23,   153,   148,   151,     8,   142,   143,   125,   129,   112,
     112,    99,   141,   131,    66,   119,     9,   100,   107,    27,
      28,    29,    30,    54,    55,    56,    34,    57,    27,    28,
      29,    30,    54,    55,    56,    34,    57,   -59,   134,    89,
      23,     4,     5,   -59,     6,    62,   135,   146,   113,   150,
     150,   150,    81,     8,    52,    63,   136,    68,   150,     4,
       5,    52,    91,    77,   137,     9,   159,   107,    27,    28,
      29,    30,    54,    55,    56,    34,    57,    64,    65,     4,
       5,   122,     6,     9,    76,    23,     4,     5,    69,     6,
      78,     8,    81,   147,    79,    52,    80,    68,     8,    70,
      71,    72,   179,     9,    81,    10,     4,     5,    82,    91,
       9,   188,   107,    27,    28,    29,    30,    54,    55,    56,
      34,    57,     4,     5,   202,     6,   120,     1,     2,   194,
       9,   121,    10,    88,     8,    81,   219,    23,     4,     5,
      94,     6,   209,    96,   206,    97,     9,    81,   107,   212,
       8,     4,     5,    23,     6,   102,    41,    24,     7,   221,
     222,    25,     9,     8,   107,    27,    28,    29,    30,    54,
      55,    56,    34,    57,    26,     9,   126,    10,   -11,    67,
     138,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      23,   104,   105,   123,    24,   132,   133,   127,    25,    83,
      84,    85,    86,    87,    95,     4,     5,    23,     6,    45,
      46,    26,   118,   139,   -11,    67,    90,     8,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    53,   144,     9,
     145,    10,   174,   175,    67,    27,    28,    29,    30,    54,
      55,    56,    34,    57,   223,   224,   225,   226,   227,   228,
     229,    83,    84,    85,    86,    87,   195,   196,   155,   231,
     232,   157,   158,   163,   164,   160,   165,   166,   167,   169,
     170,   168,   171,   172,   173,   177,   184,   180,   185,   190,
     189,   181,   199,   197,   198,   203,   204,   210,   207,   208,
     213,   214,   216,   217,   215,   220,    47,    48,   192,   115,
     130,   218,    98,   233,   191,     0,     0,     0,     0,     0,
       0,     0,   103
};

static const yytype_int16 yycheck[] =
{
       5,     5,     1,     8,    16,     7,    25,     6,    45,    46,
     106,     6,     7,    65,     9,    12,    10,   113,    13,    32,
      24,     6,     0,    18,    12,   105,   106,    40,    10,    20,
      27,     6,     6,   113,    28,    30,     6,    32,    33,    34,
      52,     5,     6,     7,    32,     9,    28,    32,    53,    13,
       5,   147,   104,   105,    18,    92,    93,    32,    32,    64,
      65,    19,    32,    82,    20,    67,    30,    25,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    19,     6,     8,
       5,     6,     7,    25,     9,    28,    14,   101,    13,   104,
     105,   106,    21,    18,   106,    13,     6,   119,   113,     6,
       7,   113,     9,     9,    14,    30,   118,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    35,    36,     6,
       7,    10,     9,    30,    32,     5,     6,     7,    11,     9,
       9,    18,    21,    13,     9,   147,     9,   159,    18,    22,
      23,    24,   157,    30,    21,    32,     6,     7,    20,     9,
      30,   165,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,     6,     7,    10,     9,    27,     3,     4,   178,
      30,    32,    32,     8,    18,    21,    10,     5,     6,     7,
      10,     9,   197,    10,   193,    10,    30,    21,    32,   203,
      18,     6,     7,     5,     9,     6,     8,     9,    13,   214,
     215,    13,    30,    18,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    26,    30,    32,    32,    20,    21,
       6,    33,    34,    35,    36,    37,    38,    39,    40,    41,
       5,    35,    36,    31,     9,    16,    17,    32,    13,    13,
      14,    15,    16,    17,    10,     6,     7,     5,     9,    33,
      34,    26,    13,     6,    20,    21,    30,    18,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    25,    19,    30,
      19,    32,    31,    32,    21,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    13,    14,    15,    16,    17,    18,
      19,    13,    14,    15,    16,    17,    14,    15,    28,    16,
      17,    29,     9,    27,    27,    32,    27,    27,    27,     6,
       6,    27,     6,     6,     6,    28,     6,    32,    32,     6,
      32,    12,    27,    29,    12,    27,    27,     6,    32,    32,
       6,    29,    10,    10,    29,    10,     6,     6,   176,    65,
      81,   211,    53,    32,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    43,     6,     7,     9,    13,    18,    30,
      32,    44,    45,    46,    48,    55,    56,    57,    58,    62,
      63,    65,    66,     5,     9,    13,    26,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    70,    71,    72,    76,
       0,     8,    64,    70,    72,    33,    34,    44,    48,    55,
      67,    69,    56,    25,    37,    38,    39,    41,    60,    72,
       6,    32,    28,    13,    35,    36,    20,    21,    57,    11,
      22,    23,    24,    59,    70,    76,    32,     9,     9,     9,
       9,    21,    20,    13,    14,    15,    16,    17,     8,     8,
      30,     9,    62,    62,    10,    10,    10,    10,    60,    19,
      25,    61,     6,    63,    35,    36,    13,    32,    49,    50,
      51,    55,    72,    13,    49,    51,    32,    40,    13,    56,
      27,    32,    10,    31,     6,    32,    32,    32,     6,    32,
      71,    76,    16,    17,     6,    14,     6,    14,     6,     6,
       6,    32,    62,    62,    19,    19,    70,    13,    49,    53,
      72,    49,    53,    50,    53,    28,    53,    29,     9,    56,
      32,    12,    27,    27,    27,    27,    27,    27,    27,     6,
       6,     6,     6,     6,    31,    32,    68,    28,    52,    72,
      32,    12,    12,    32,     6,    32,    73,    74,    70,    32,
       6,    74,    68,    54,    55,    14,    15,    29,    12,    27,
      10,    28,    10,    27,    27,    10,    55,    32,    32,    72,
       6,    75,    70,     6,    29,    29,    10,    10,    73,    10,
      10,    72,    72,    13,    14,    15,    16,    17,    18,    19,
      47,    16,    17,    32
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    42,    43,    43,    44,    44,    44,    45,    45,    45,
      46,    46,    47,    47,    47,    47,    47,    47,    47,    47,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      49,    49,    49,    50,    52,    51,    54,    53,    55,    55,
      55,    55,    56,    56,    57,    57,    57,    57,    57,    58,
      58,    58,    59,    59,    59,    59,    59,    59,    59,    60,
      61,    60,    62,    62,    63,    63,    63,    63,    63,    63,
      64,    64,    65,    65,    66,    66,    67,    67,    68,    68,
      69,    70,    70,    71,    71,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    73,    73,    74,    75,    74,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     1,     1,     1,     9,     9,    10,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       3,     4,     3,     4,     3,     4,     4,     3,     4,     4,
       1,     2,     1,     1,     0,     4,     0,     4,     1,     2,
       3,     4,     1,     2,     1,     2,     3,     4,     4,     1,
       3,     3,     1,     1,     1,     3,     5,     4,     4,     1,
       0,     3,     1,     3,     1,     3,     3,     1,     1,     2,
       4,     3,     3,     2,     3,     3,     3,     5,     1,     1,
       3,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     4,
       3,     3,     4,     4,     3,     4,     3,     4,     2,     3,
       2,     3,     6,     6,     8,     8,     6,     8
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if CQLDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !CQLDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !CQLDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 205 "cqpeval.y" /* yacc.c:1646  */
    {
          queryResult = (yyvsp[0].evalRes);
     }
#line 1660 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 209 "cqpeval.y" /* yacc.c:1646  */
    {
          queryResult = createEvalResult((yyvsp[0].fs));
     }
#line 1668 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 216 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1676 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 220 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].rs));
     }
#line 1684 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 6:
#line 224 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].rs));
     }
#line 1692 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 231 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterPos((yyvsp[-8].rs), getAttr((yyvsp[-4].str)), getAttr((yyvsp[0].str)), RQFilterPos::F_EQ, (yyvsp[-6].num), (yyvsp[-2].num));
     }
#line 1700 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 235 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterPos((yyvsp[-8].rs), getAttr((yyvsp[-4].str)), getAttr((yyvsp[0].str)), RQFilterPos::F_NEQ, (yyvsp[-6].num), (yyvsp[-2].num));
     }
#line 1708 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 239 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterFreq((yyvsp[-9].rs), getAttr((yyvsp[-3].str)), (yyvsp[-1].globop).op, (yyvsp[-1].globop).neg, (yyvsp[-5].num), (yyvsp[0].num));
     }
#line 1716 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 246 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].rs);
     }
#line 1724 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 250 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].evalRes).toRangeStream();
     }
#line 1732 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 257 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_EQ;
          (yyval.globop).neg = 0;
     }
#line 1741 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 262 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_EQ;
          (yyval.globop).neg = 1;
     }
#line 1750 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 267 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 0;
     }
#line 1759 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 272 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 0;
     }
#line 1768 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 277 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 1;
     }
#line 1777 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 282 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 1;
     }
#line 1786 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 287 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 1;
     }
#line 1795 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 292 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 1;
     }
#line 1804 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 300 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQinNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1812 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 304 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1820 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 310 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQcontainNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1828 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 314 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1836 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 320 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQinNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1844 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 324 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1852 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 328 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1860 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 334 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQcontainNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1868 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 338 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1876 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 342 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1884 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 349 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].rs);
     }
#line 1892 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 353 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQoutsideNode((yyvsp[0].rs), defaultCorp->size());
     }
#line 1900 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 357 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].evalRes).toRangeStream();
     }
#line 1908 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 364 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = new SequenceStream(0, lastPosition, defaultCorp->size());
          (yyval.rs) = new RQRepeatFSNode(f, (yyvsp[0].num), (yyvsp[0].num));
     }
#line 1917 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 371 "cqpeval.y" /* yacc.c:1646  */
    {
          tmpCorp = currCorp;
          alCorp = currCorp->get_aligned((yyvsp[-1].str));
          alCorp->set_default_attr(currCorp->get_default_attr()->name);
          currCorp = alCorp;
     }
#line 1928 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 378 "cqpeval.y" /* yacc.c:1646  */
    {
          currCorp = tmpCorp;
          (yyval.rs) = currCorp->map_aligned(alCorp, (yyvsp[0].evalRes).toRangeStream(), true);
     }
#line 1937 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 385 "cqpeval.y" /* yacc.c:1646  */
    {
          tmpCorp = currCorp;
          alCorp = currCorp->get_aligned((yyvsp[-1].str));
          alCorp->set_default_attr(currCorp->get_default_attr()->name);
          currCorp = alCorp;
     }
#line 1948 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 392 "cqpeval.y" /* yacc.c:1646  */
    {
          currCorp = tmpCorp;
          (yyval.rs) = currCorp->map_aligned(alCorp, (yyvsp[0].evalRes).toRangeStream(), false);
     }
#line 1957 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 400 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1965 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 404 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes).complement();
     }
#line 1973 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 408 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = operationOr((yyvsp[-2].evalRes), (yyvsp[0].evalRes));
     }
#line 1981 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 412 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = operationOr((yyvsp[-3].evalRes), (yyvsp[0].evalRes).complement());
     }
#line 1989 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 419 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1997 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 423 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = concat((yyvsp[-1].evalRes), (yyvsp[0].evalRes));
     }
#line 2005 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 430 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 2013 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 434 "cqpeval.y" /* yacc.c:1646  */
    {
          RangeStream* r = NULL;
          if ((yyvsp[0].repData).min == 0 && (yyvsp[0].repData).max == 1) {
               if ((yyvsp[-1].evalRes).r == NULL) {
                    r = (yyvsp[-1].evalRes).toRangeStream();
               } else {
                    r = (yyvsp[-1].evalRes).r;
               }
               r = new RQOptionalNode(r);
          } else if ((yyvsp[-1].evalRes).r == NULL) {
               r = new RQRepeatFSNode((yyvsp[-1].evalRes).f, (yyvsp[0].repData).min, (yyvsp[0].repData).max);
          } else {
               r = new RQRepeatNode((yyvsp[-1].evalRes).r, (yyvsp[0].repData).min, (yyvsp[0].repData).max);
          }
          (yyval.evalRes) = createEvalResult(r);
     }
#line 2034 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 451 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* begs = new BegsOfRStream((yyvsp[-1].rs));
          (yyval.evalRes) = createEvalResult(new Pos2Range(begs, 0, 0));
     }
#line 2043 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 456 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[-2].rs));
     }
#line 2051 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 460 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* ends = new EndsOfRStream((yyvsp[-1].rs));
          (yyval.evalRes) = createEvalResult(new Pos2Range(ends, 0, 0));
     }
#line 2060 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 468 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].fs));
     }
#line 2068 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 472 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[-1].evalRes);
     }
#line 2076 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 476 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[-1].rs));
     }
#line 2084 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 483 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 0;
          (yyval.repData).max = -1;
     }
#line 2093 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 488 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 1;
          (yyval.repData).max = -1;
     }
#line 2102 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 493 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 0;
          (yyval.repData).max = 1;
     }
#line 2111 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 498 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = (yyvsp[-1].num);
          (yyval.repData).max = (yyvsp[-1].num);
     }
#line 2120 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 503 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = (yyvsp[-3].num);
          (yyval.repData).max = (yyvsp[-1].num);
     }
#line 2129 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 508 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 0;
          (yyval.repData).max = (yyvsp[-1].num);
     }
#line 2138 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 513 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = (yyvsp[-2].num);
          (yyval.repData).max = -1;
     }
#line 2147 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 521 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = currCorp->get_struct((yyvsp[0].str))->rng->whole();
     }
#line 2155 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 525 "cqpeval.y" /* yacc.c:1646  */
    {
          currStruc = currCorp->get_struct((yyvsp[0].str));
          currCorp = currStruc;
     }
#line 2164 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 530 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = currStruc->rng->part((yyvsp[0].fs));
          currCorp = defaultCorp;
     }
#line 2173 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 538 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2181 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 542 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new AddLabel((yyvsp[0].fs), (yyvsp[-2].num));
     }
#line 2189 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 549 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = currCorp->get_default_attr()->regexp2poss((yyvsp[0].str), ignoreCase);
     }
#line 2197 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 553 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2205 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 557 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2213 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 561 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2221 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 565 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2229 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 569 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream(0, lastPosition, defaultCorp->size());
     }
#line 2237 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 576 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, (yyvsp[-3].str), (yyvsp[0].str), (yyvsp[-1].num));
          #else
          throw EvalQueryException("thesaurus available in NoSketchEngine");
          #endif
     }
#line 2249 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 584 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, (yyvsp[-2].str), (yyvsp[0].str), 0);
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2261 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 595 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, "-", (yyvsp[0].str), (yyvsp[-1].num));
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2273 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 603 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, "-", (yyvsp[0].str), 0);
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2285 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 614 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2293 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 618 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2301 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 625 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = concatFs((yyvsp[-1].fs), (yyvsp[0].fs));
     }
#line 2309 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 629 "cqpeval.y" /* yacc.c:1646  */
    {
          int num1 = (yyvsp[-1].num);
          int num2 = (yyvsp[0].num);

          if (num1 == num2) {
               (yyval.fs) = concatFs((yyvsp[-3].fs), (yyvsp[-2].fs));
          } else if (num1 > num2) {
               (yyval.fs) = new EmptyStream();
          } else {
               RangeStream* r1 = new Pos2Range((yyvsp[-3].fs), 0, 1);
               RangeStream* r2 = new Pos2Range((yyvsp[-2].fs), -num2, -num1+1);
               (yyval.fs) = new BegsOfRStream(new RQinNode(r1, r2));
          }
     }
#line 2328 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 647 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.num) = (yyvsp[0].num);
     }
#line 2336 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 651 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.num) = (yyvsp[0].num);
     }
#line 2344 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 658 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QOrNode((yyvsp[-1].fs), (yyvsp[0].fs));
     }
#line 2352 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 665 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2360 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 669 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QOrNode((yyvsp[-2].fs), (yyvsp[0].fs));
     }
#line 2368 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 676 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2376 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 680 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QAndNode((yyvsp[-2].fs), (yyvsp[0].fs));
     }
#line 2384 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 691 "cqpeval.y" /* yacc.c:1646  */
    {
          seek << (yyvsp[0].num);
     }
#line 2392 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 694 "cqpeval.y" /* yacc.c:1646  */
    {
          /* empty */
     }
#line 2400 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 701 "cqpeval.y" /* yacc.c:1646  */
    { seek << ":"; }
#line 2406 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 706 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->regexp2poss((yyvsp[0].str), ignoreCase);
     }
#line 2414 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 710 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-2].str))->regexp2poss((yyvsp[0].str), ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2423 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 715 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = exactMatch((yyvsp[-3].str), (yyvsp[0].str));
     }
#line 2431 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 719 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = exactMatch((yyvsp[-3].str), (yyvsp[0].str));
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2440 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 724 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->compare2poss((yyvsp[0].str), WORD_LESS_OR_EQUALS, ignoreCase);
     }
#line 2448 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 728 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-3].str))->compare2poss((yyvsp[0].str), WORD_LESS_OR_EQUALS, ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2457 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 733 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->compare2poss((yyvsp[0].str), WORD_GREATER_OR_EQUALS, ignoreCase);
     }
#line 2465 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 737 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-3].str))->compare2poss((yyvsp[0].str), WORD_GREATER_OR_EQUALS, ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2474 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 742 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream((yyvsp[0].num), (yyvsp[0].num), defaultCorp->size());
     }
#line 2482 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 746 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream((yyvsp[-1].num), -1*(yyvsp[0].num), defaultCorp->size());
     }
#line 2490 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 750 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QNotNode((yyvsp[0].fs), defaultCorp->size());
     }
#line 2498 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 754 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2506 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 758 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          int level = (yyvsp[-3].num);
          (yyval.fs) = getWMapPoss(currCorp->get_conf("WSBASE"), level, seek.str().c_str());
          seek.str(string());
          seek.clear();
          #else
          throw EvalQueryException("word sketches not available in NoSketchEngine");
          #endif
     }
#line 2521 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 769 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          int level = (yyvsp[-3].num);
          (yyval.fs) = getWMapPoss(currCorp->get_conf("TERMBASE"), level, seek.str().c_str());
          seek.str(string());
          seek.clear();
          #else
          throw EvalQueryException("terms not available in NoSketchEngine");
          #endif
     }
#line 2536 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 780 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          const char* gr = (yyvsp[-3].str);
          const char *pat1 = (const char *) (yyvsp[-5].str);
          const char *pat2 = (const char *) (yyvsp[-1].str);
          (yyval.fs) = getWMapPossMatchingRegexp(currCorp->get_conf("WSBASE"), gr, pat1, pat2);
          #else
          throw EvalQueryException("word sketches not available in NoSketchEngine");
          #endif
     }
#line 2551 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 791 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef SKETCH_ENGINE
          const char* gr = (yyvsp[-3].str);
          const char *pat1 = (const char *) (yyvsp[-5].str);
          const char *pat2 = (const char *) (yyvsp[-1].str);
          (yyval.fs) = getWMapPossMatchingRegexp(currCorp->get_conf("TERMBASE"), gr, pat1, pat2);
          #else
          throw EvalQueryException("terms not available in NoSketchEngine");
          #endif
     }
#line 2566 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 802 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* src = (yyvsp[-1].fs);
          int coll = (yyvsp[-3].num);
          (yyval.fs) = new SwapKwicColl(src, coll);
     }
#line 2576 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 808 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* src = (yyvsp[-1].fs);
          int from = (yyvsp[-5].num);
          int to = (yyvsp[-3].num);
          (yyval.fs) = new ChangeLabel(src, from, to);
     }
#line 2587 "cqpeval.cc" /* yacc.c:1646  */
    break;


#line 2591 "cqpeval.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 816 "cqpeval.y" /* yacc.c:1906  */


char cqlCurrChar() {
     return query[pos];
}

char cqlNextChar() {
     if (pos+1 == (ssize_t) query.size()) {
          return 0;
     }
     return query[pos+1];
}

char* readRegexp() {
     // read until another apostrophe (without backslash) is reached
     int from = pos;
     int slashes = 0;
     while (pos < (ssize_t) query.size() && (cqlCurrChar() != '"' || slashes % 2 == 1)) {
          if(cqlCurrChar() == '\\') {
               slashes++;
          } else {
               slashes = 0;
          }
          pos++;
     }
     int size = pos-from;
     char* regexp = (char*) malloc(sizeof(char)*(size+1));
     memcpy(regexp, &query[from], size);
     regexp[size] = '\0';
     pos++;
     return regexp;
}

bool cqlIsAlpha(char c) {
     return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool cqlIsNumber(char c) {
     return '0' <= c && c <= '9';
}

void skipSpaces() {
     while (pos < (ssize_t) query.size() && (cqlCurrChar() == ' ' || cqlCurrChar() == '\t')) {
          pos++;
     }
}

long long readNumber() {
     int from = pos++;
     while (pos < (ssize_t) query.size() && cqlIsNumber(cqlCurrChar())) {
          pos++;
     }
     string numStr = query.substr(from, pos-from);
     return atoll(numStr.c_str());
}

string readWord() {
     int from = pos++;
     while (pos < (ssize_t) query.size() && (cqlIsAlpha(cqlCurrChar()) ||
        cqlCurrChar() == '_' || cqlCurrChar() == '@' || cqlIsNumber(cqlCurrChar()))) {
          pos++;
     }
     return query.substr(from, pos-from);
}

int yylex() {
     if (pos < 0) {
          pos = 0;
          if (onepos) return START_ONEPOS;
          else return START_QUERY;
     }

     startpos = pos;

     if (pos >= (ssize_t) query.size()) {
          return 0;
     }
     
     bool negativeNumber = (cqlCurrChar() == '-' && cqlIsNumber(cqlNextChar()));
     if (negativeNumber || cqlIsNumber(cqlCurrChar())) {
          if (negativeNumber) {
               pos++;
          }
          yylval.num = readNumber();
          if (negativeNumber) {
               yylval.num *= -1;
               return NNUMBER;
          }
          return NUMBER;
     }
     
     // word
     if (cqlIsAlpha(cqlCurrChar()) || cqlCurrChar() == '_') {
          string word = readWord();
          char* str = new char[word.size()+1];
          word.copy(str, word.size());
          str[word.size()] = '\0';
          yylval.str = str;
          if (word == "f")
               return KW_FREQ;
          if (word == "meet")
               return KW_MEET;
          if (word == "union")
               return KW_UNION;
          if (word == "within")
               return KW_WITHIN;
          if (word == "containing")
               return KW_CONTAINING;
          if (word == "ws")
               return KW_WS;
          if (word == "term")
               return KW_TERM;
          if (word == "swap")
               return KW_SWAP;
          if (word == "ccoll")
               return KW_CCOLL;
          return WORD;
     }

     char c = cqlCurrChar();
     char next = cqlNextChar();
     pos++;

     switch (c) {
          case '"':
          {
               char* s = readRegexp();
               yylval.str = s;
               return REGEXP;
          }
          case '\t': // skip
          case ' ':
               skipSpaces();
               return yylex();
          case '[':
               return LBRACKET;
          case ']':
               return RBRACKET;
          case '=':
               return EQ;
          case '<':
               if (next == '=') {
                    pos++;
                    return LEQ;
               }
               return LSTRUCT;
          case '>':
               if (next == '=') {
                    pos++;
                    return GEQ;
               }
               return RSTRUCT;
          case '&':
               return BIN_AND;
          case '|':
               return BIN_OR;
          case '!':
               if (next == '=') {
                    pos++;
                    return NEQ;
               }
               return NOT;
          case '(':
               return LPAREN;
          case ')':
               return RPAREN;
          case '{':
               return LBRACE;
          case '}':
               return RBRACE;
          case '*':
               return STAR;
          case '+':
               return PLUS;
          case '?':
               return QUEST;
          case '/':
               return SLASH;
          case '#':
               return POSNUM;
          case ',':
               return COMMA;
          case ':':
               return COLON;
          case '.':
               return DOT;
          case '~':
               return TEQ;
          case ';':
               if (pos == (ssize_t) query.size()) {
                    return 0;
               }
               break;
     }

     std::ostringstream ss;
     ss << "unexpected character";
     if(c>=32 && c<=127) ss << " " << c;
     ss << " at position " << utf8pos(query.c_str(), pos);
     throw EvalQueryException(ss.str());
}

evalResult eval(const char* cqpQuery, Corpus *corp, bool eval_onepos) {
     if (!corp)
          throw EvalQueryException ("Internal Error: eval_cqpquery(corp==NULL)");
     if (!cqpQuery)
          throw EvalQueryException ("Internal Error: eval_cqpquery(query==NULL)");
     if (!*cqpQuery)
          throw EvalQueryException ("Internal Error: eval_cqpquery(query[0]==NULL)");

     defaultCorp = corp;
     currCorp = defaultCorp;
     lastPosition = defaultCorp->size()-1;
     query = cqpQuery;
     pos = -1;
     startpos = -1;
     onepos = eval_onepos;

     int ret = yyparse();

     if (ret != 0) {
          throw EvalQueryException(errMsg);
     }
     return queryResult;
}

RangeStream *eval_cqpquery (const char *query, Corpus *corp) {
     evalResult res = eval(query, corp, false);
     return res.toRangeStream();
}

FastStream *eval_cqponepos (const char *query, Corpus *corp) {
     evalResult res = eval(query, corp, true);
     if (res.f == NULL) {
          throw EvalQueryException("Not one pos query");
     }
     return res.f;
}

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
